diff -bruN freeswan-1.9.orig/doc/pkix/openssl-ca.quickstart freeswan-1.9/doc/pkix/openssl-ca.quickstart
--- freeswan-1.9.orig/doc/pkix/openssl-ca.quickstart	Wed Dec 31 19:00:00 1969
+++ freeswan-1.9/doc/pkix/openssl-ca.quickstart	Mon Jun  4 11:34:31 2001
@@ -0,0 +1,237 @@
+This document is much like a quickstart, but in an even shorter form.
+These are the steps I took to create an opensourced CA capable of signing 
+certificates.
+
+How I set up a CA on RedHat 6.2 and used it:
+
+
+1- install openssl on the CA. 
+If the openssl package is already installed, then ignore this 
+section. Please note: requires 0.9.5a. I doubt FreeSWAN will
+run with openssl 0.9.6.
+----------------------------------------------------------------
+cd /usr/src/redhat/SRPMS
+scp root@10.8.49.101:/usr/src/redhat/SRPMS/openssl*.src.rpm .
+rpm --rebuild openssl-0.9.5a-1.src.rpm
+cd ../RPMS/i386/
+rpm -i openssl-*
+
+
+2- Setting up the openssl CA.
+The openssl RPM already create a /var/lib/ssl directory. If you installed
+openssl from source, look for it in either /usr/ssl, /usr/local/ssl,
+or even /usr/share/ssl.
+----------------------------------------------------------------
+cd /var/lib/ssl
+# Note! Newer redhat openssl RPMs created the dir in /usr/share/ssl
+
+# will simplify finding global conf files.
+ln -s /etc etc 
+
+# see README.certificates, section 4.1, for instructions
+# on the creation/addition of openssl.cnf 
+# Note! Since Redhat redid its openssl packages, openssl.cnf is present.
+# Use it instead.
+vi /etc/openssl.cnf
+
+# see README.certificates, section 4.1, for instructions
+# on the CA extensions to define in ca.ext
+vi ca.ext 
+
+openssl req -new -newkey rsa:1024 -keyout \
+	private/cakey.pem -out careq.pem
+# Please enter in a password to be able to use the CA's signing cert once 
+# it is generated. Only that password will unlock it for use.
+# Data may be asked of you to enter.
+# ____________________________________________________________________
+# --- Country Name (2 letter code) [AU]:
+# --- State or Province Name (full name) [Some-State]:
+# --- Locality Name (eg, city) []:
+# **important** The OrgName must match on ALL certs which will be signed
+# by this self-signed cert.
+#   --- Organization Name (eg, company) [Internet Widgits Pty Ltd]:
+# --- Organizational Unit Name (eg, section) []:
+# **Note** Try to use the machine's FQDN as common name. Not your own
+# name. :
+#   --- Common Name (eg, your name or your server's hostname) []:
+# --- Email Address []:
+# ____________________________________________________________________
+#
+# Unimportant:
+# Please enter the following 'extra' attributes
+# to be sent with your certificate request
+# A challenge password []:
+# An optional company name []:
+
+# sign our own CA certificate.
+openssl x509 -CAcreateserial -signkey private/cakey.pem -req \
+	-in careq.pem -out cacert.pem -days 2000 -extfile ca.ext
+
+touch index.txt
+echo "01" > serial
+openssl ca -gencrl -out crl.pem; # distribute/make available to all hosts.
+
+
+3- adding cacert.pem and crl.pem to hosts (OPTIONAL)
+Unless you are using LDAP lookup, you will have to make the certificate
+available on all the client hosts. Of course, make sure the destination 
+directory exists.
+----------------------------------------------------------------
+scp crl.pem 10.1.49.233:/etc/ipsec
+scp cacert.pem 10.1.49.233:/etc/ipsec
+scp crl.pem 10.8.49.101:/etc/ipsec
+scp cacert.pem 10.8.49.101:/etc/ipsec
+
+
+4- Each client host -- generate certificate requests.
+The CA's signing certificate is ready. Now we can create the client
+certificates. 
+NOTE: a CA can also be its own client if a separate certificate
+is generated. Both the cacert.pem and the host certificates must be
+made available as standard host certificates, as if they were 2 separate
+hosts.
+----------------------------------------------------------------
+mkdir -p /etc/ipsec
+cd /etc/ipsec
+
+# Make sure the info entered for the "CommonName" for each client 
+#   is DIFFERENT, usually containing the hostname.
+# Make sure the "OrgName" used is the same as the one used 
+#   for cacert.pem's creation.
+# Make sure you don't create this certificate with a password.
+#  This certificate must be available for use without user intervention.
+#  (that includes password entry)
+openssl req -new -newkey rsa:1024 -nodes -keyout \
+	`hostname`.key -out `hostname`.req.pem
+############################
+# OR DSA: (still unsupported. left note in to remember how to do it)
+# openssl dsaparam 1024 -out dsa_params.txt
+# chmod 400 dsa_params.txt
+#openssl req -new -newkey dsa:dsa_params.txt -nodes -keyout \
+#        /etc/ipsec/`hostname`.key -out /etc/ipsec/`hostname`.req.pem
+#remember that all parties must use DSA
+############################
+
+# how about a generic name on each host for ease?
+ln -fs `hostname`.key privkey.pem
+ln -fs `hostname`.pem pubcert.pem; # will be created soon.
+
+# protect the private key.
+chmod 400 `hostname`.key
+
+
+
+5- Signing certificates on the CA host
+Signing the certificates is a necessary step in the pkix CA setup,
+but first, you must give your CA the ability.
+You may find the signIPSEC script handy.
+----------------------------------------------------------------
+###########################
+# Create/Undate the following ONCE.
+# Once again, note the paths may be wrong.
+vi /etc/openssl.cnf; # (see README.certificates section 4.6)
+
+# Either create signIPSEC, or copy it from the current directory.
+#   to /usr/local/bin on the CA host.
+vi /usr/local/bin/signIPSEC; # (see README.certificates section 4.6)
+
+chmod 700 /usr/local/bin/signIPSEC
+# use: signIPSEC foo.mydomain.com 192.168.1.5 foo.req
+
+# Once again, CD to the correct path.
+cd /var/lib/ssl/
+mkdir -p newcerts
+
+# The following steps can be reused over and over, for each host to add
+#
+# 1- copy over the unsigned public cert from the host.
+scp root@10.1.49.233:/etc/ipsec/*.req.pem .
+#
+# 2- sign it with the correct values.
+signIPSEC sticky.netwinder.org 10.1.49.233 sticky.req.pem
+#
+# 3- copy the newly signed certificate to the host.
+scp newcerts/`cat serial.old`.pem root@10.1.49.233:/etc/ipsec/sticky.pem
+#
+# 4- rehash the current database of certificates handled by the CA.
+mv newcerts/* certs/
+c_rehash certs
+
+
+
+6- CA host: prepping flat file for client hosts
+Here's a short script for quick generations of text flatfiles needed
+by the various clients. LDAP lookup is prefered, but flatfile is available
+for testing or simplicity.
+The script is available as "CA-regenerate-flatfile.sh".
+----------------------------------------------------------------
+#!/bin/sh -x
+
+if [ -d /var/lib/ssl ]; then
+  cd /var/lib/ssl
+elif [ -d /usr/lib/ssl ]; then
+  cd /usr/lib/ssl
+elif [ -d /usr/local/lib/ssl ]; then
+  cd /usr/local/lib/ssl
+elif [ -d /usr/share/ssl ]; then
+  cd /usr/share/ssl
+else
+  echo "ERROR: Cannot determine location of ssl directory."
+  exit 1
+fi
+
+cat /dev/null > flatfile.txt
+
+for ii in certs/*.pem cacert.pem crl.pem;
+do
+  if [ "`basename $ii`" != "crl.pem" ] && [ "`basename $ii`" != "cacert.pem" ];
+  then
+    perl -e "open(IN, \"openssl x509 -in $ii -noout -text \|\"); \
+      @IN = <IN>; \
+      foreach (@IN) { \
+        if (/IP Address:(\\d{1,3}\\.\\d{1,3}\\.\\d{1,3}\\.\\d{1,3})/) { \
+          print \"ip: \$1\\n\"; \
+        } \
+        if (/DNS:([^, ]*).*$/) { \
+          print \"dns: \$1\\n\"; \
+        } \
+      };" >> flatfile.txt
+  fi
+  cat $ii | \
+  perl -e '$printme = 0; while (<>) { if (/---BEGIN/) {$printme = 1;}; if ($printme) {print STDOUT $_;} }; print STDOUT "\n";' \
+  >> flatfile.txt
+done
+----------------------------------------------------------------
+
+# the flatfile is created. Send to Client hosts.
+scp flatfile.txt root@10.1.49.233:/etc/ipsec
+scp flatfile.txt root@10.8.49.101:/etc/ipsec
+
+
+
+7- revoking a certificate
+Sometimes it becomes necessary to revoke a certificate. 
+----------------------------------------------------------------
+# First, find out which certificate has to be revoked. If properly
+# generated, the CommonName (CN) will be the certificate's owner 
+# hostname. Replace "WANTED_HOSTNAME" by the hostname to look for.
+cd /var/lib/ssl/
+(
+for certs in certs/*.pem; do 
+  echo -n "$certs: " 
+  openssl x509 -in $certs -noout -subject
+done
+) | grep WANTED_HOSTNAME
+
+# Example output:
+# 02.pem: subject=/C=CA/ST=Ontario/O=Rebel.com/OU=SoftEng/CN=arm1.netwinder.org/Email=firesoul@netwinder.org
+
+# next, proceed to revoke the certificate.
+# once again, double-check the paths.
+openssl ca -revoke /var/lib/ssl/certs/02.pem 
+openssl ca -gencrl -out /var/lib/ssl/crl.pem
+
+# If we're using LDAP, the new crl.pem will be used automatically.
+# Otherwise, it has to be copied to each one of the client hosts.
+scp crl.pem root@10.1.49.233:/etc/ipsec
+scp crl.pem root@10.8.49.101:/etc/ipsec
diff -bruN freeswan-1.9.orig/doc/pkix/signIPSEC freeswan-1.9/doc/pkix/signIPSEC
--- freeswan-1.9.orig/doc/pkix/signIPSEC	Wed Dec 31 19:00:00 1969
+++ freeswan-1.9/doc/pkix/signIPSEC	Mon Jun  4 11:34:31 2001
@@ -0,0 +1,38 @@
+#!/bin/bash
+
+# Simple wrapper for "openssl ca" that sets environment to pass in
+# values for the svr_cert extension
+# P.J.Onion  23/9/1999
+# updated by: Luc Lanthier   20010214
+if [ -d /var/lib/ssl ]; then
+  SSLDIR="/var/lib/ssl";
+elif [ -d /usr/lib/ssl ]; then
+  SSLDIR="/usr/lib/ssl";
+elif [ -d /usr/local/lib/ssl ]; then
+  SSLDIR="/usr/local/lib/ssl";
+elif [ -d /usr/share/ssl ]; then
+  SSLDIR="/usr/share/ssl";
+else
+  echo "ERROR: Cannot determine location of ssl directory."
+  exit 1
+fi
+
+
+if test $# -ne 3 ; then
+        echo "Usage: $0 hostname ipaddress reqfile"
+        exit 1
+fi
+
+
+HOSTFQDN=$1
+HOSTIP=$2
+NSCOMMENT="IPsec Certificate for $1"
+EXTENSION=svr_cert
+
+export HOSTFQDN HOSTIP NSCOMMENT EXTENSION
+if (which openssl &> /dev/null) ; then
+  openssl ca -in $3
+else
+  echo "ERROR: Cannot locate/execute openssl binary."
+  exit 1
+fi
diff -bruN freeswan-1.9.orig/ipsec.conf.def freeswan-1.9/ipsec.conf.def
--- freeswan-1.9.orig/ipsec.conf.def	Wed Dec 31 19:00:00 1969
+++ freeswan-1.9/ipsec.conf.def	Wed May 16 10:57:20 2001
@@ -0,0 +1,26 @@
+# /etc/ipsec.conf - FreeS/WAN IPSEC configuration file
+
+# More elaborate and more varied sample configurations can be found
+# in doc/examples.
+
+# basic configuration
+config setup
+	# THIS SETTING MUST BE CORRECT or almost nothing will work;
+	# %defaultroute is okay for most simple cases.
+	interfaces=%defaultroute
+	# Debug-logging controls:  "none" for (almost) none, "all" for lots.
+	klipsdebug=none
+	plutodebug=none
+	# Use auto= parameters in conn descriptions to control startup actions.
+	plutoload=%search
+	plutostart=%search
+
+# defaults for subsequent connection descriptions
+conn %default
+	# How persistent to be in (re)keying negotiations (0 means very).
+	keyingtries=3
+	# Authentication by RSA signature keys
+	authby=rsasig
+	# keylife of 8h is too long for rekeying drops.
+	keylife=1h
+
diff -bruN freeswan-1.9.orig/klips/doc/DONE freeswan-1.9/klips/doc/DONE
--- freeswan-1.9.orig/klips/doc/DONE	Mon Nov  6 00:09:00 2000
+++ freeswan-1.9/klips/doc/DONE	Mon Jun  4 12:54:57 2001
@@ -1,8 +1,12 @@
 *
-* RCSID $Id: DONE,v 1.20 2000/11/06 05:09:00 rgb Exp $
+* RCSID $Id: DONE,v 1.22 2001/06/01 07:25:19 rgb Exp $
 *
 
 Bugs as of 0.90:
+	auto AH+ESP transport mode oops?
+	ipcomp: fix i[56]86 ASM code 2.4 makefile issues
+	kill single-letter options from klips utils manpages.
+	add --label to klips utils manpages
 	ah tunnel -- 3 esp packets kills the sg
 	single spi ungroup fails
 	elucidate the meaning of 'tdb' in all error message references
@@ -180,6 +184,9 @@
 	Oops if IPCOMP not config in KLIPS but negotiated by pluto.
 	Passthrough packets must be sent with frag in mind.
 
+1.9
+	Add magic saids for pass, drop, reject, trap, hold
+
 Features for 2.0:
 	Investigate PMTU (rfc2401-4.4.2, 6.1.2)
 	Mark incoming packets as from ipsec0 for accounting and validation
@@ -200,6 +207,12 @@
 
 *
 * $Log: DONE,v $
+* Revision 1.22  2001/06/01 07:25:19  rgb
+* Clean up miscellaneous stuff...
+*
+* Revision 1.21  2001/02/26 20:11:12  rgb
+* Post 1.9 candidate, magic SAs and email purge updates.
+*
 * Revision 1.20  2000/11/06 05:09:00  rgb
 * A few bugfixes...
 *
diff -bruN freeswan-1.9.orig/klips/doc/TODO freeswan-1.9/klips/doc/TODO
--- freeswan-1.9.orig/klips/doc/TODO	Mon Jan 29 17:29:46 2001
+++ freeswan-1.9/klips/doc/TODO	Mon Jun  4 12:54:57 2001
@@ -1,11 +1,23 @@
 *
-* RCSID $Id: TODO,v 1.65 2001/01/29 22:29:46 rgb Exp $
+* RCSID $Id: TODO,v 1.70 2001/06/01 07:25:19 rgb Exp $
 *
 
 fordhr:	enforce 4k msg limit.
 
 Bugs:
-	IPCOMP frag-in-clear
+	fix tncfg output after attached physical I/F disappears.
+	detach, but don't down ipsec virtual device if attached physical
+		device disappears
+	fix pfkey_update:new tdb should add to, not replace original
+	implement self-documenting kernel code:
+		http://kernelbook.sourceforge.net/#kdocs
+	replace IKE bypass machinery with SPD entries.
+	add hold machinery to store the last packet sent to the hold eroute
+		and re-inject it once the hold is deleted. (eroute entry or
+		separate table?)
+	implement eroute reject IMCP "communication administratively prohibited"
+	fix lifetime_byte_c len/ilen assignment
+	IPCOMP frag-in-clear?
 	pick-next-less-specific-eroute for intermediate tunnel lookup
 		for IKE passthrough.
 	sparc64:klips/net/ipsec/ipsec_tunnel.c:2106/2912:
@@ -106,6 +118,8 @@
 			expire (written, needs testing)
 Most	Expire SA's on soft/hard time/seq/qty and signal user (pfkey) (written, needs testing)
 GG	Port to IPv6
+	satot() conversion for /proc spi display
+	xlen, skb->len review for bogus packets, skb->len must be larger than ip->totlen
 
 2.0:
 	Port to ipchains/netfilter (with ifdefs to virtual device paradigm)
@@ -137,6 +151,21 @@
 
 *
 * $Log: TODO,v $
+* Revision 1.70  2001/06/01 07:25:19  rgb
+* Clean up miscellaneous stuff...
+*
+* Revision 1.69  2001/05/19 02:30:00  rgb
+* Added a couple of klips utils doc bugs.
+*
+* Revision 1.68  2001/04/19 19:03:37  rgb
+* Added note to update in update rather than replace.
+*
+* Revision 1.67  2001/03/16 07:30:20  rgb
+* Add 2.4 ipcomp asm note.
+*
+* Revision 1.66  2001/02/26 20:11:12  rgb
+* Post 1.9 candidate, magic SAs and email purge updates.
+*
 * Revision 1.65  2001/01/29 22:29:46  rgb
 * Add dhr suggestion.
 *
diff -bruN freeswan-1.9.orig/klips/net/ipsec/Config.in freeswan-1.9/klips/net/ipsec/Config.in
--- freeswan-1.9.orig/klips/net/ipsec/Config.in	Fri Sep 15 07:37:00 2000
+++ freeswan-1.9/klips/net/ipsec/Config.in	Mon Jun  4 11:34:31 2001
@@ -27,6 +27,7 @@
 bool '   IPSEC: Encapsulating Security Payload' CONFIG_IPSEC_ESP
 if [ "$CONFIG_IPSEC_ESP" = "y" ]; then
   bool '      3DES encryption algorithm' CONFIG_IPSEC_ENC_3DES
+  bool '      DES encryption algorithm' CONFIG_IPSEC_ENC_DES
 fi
 
 bool '   IPSEC: IP Compression' CONFIG_IPSEC_IPCOMP
diff -bruN freeswan-1.9.orig/klips/net/ipsec/Makefile freeswan-1.9/klips/net/ipsec/Makefile
--- freeswan-1.9.orig/klips/net/ipsec/Makefile	Mon Jan 29 17:19:06 2001
+++ freeswan-1.9/klips/net/ipsec/Makefile	Tue Jun 12 15:56:33 2001
@@ -54,6 +54,7 @@
 EXTRA_CFLAGS += -Wbad-function-cast 
 
 obj-$(CONFIG_IPSEC_ENC_3DES) += libdes/libdes.a
+obj-$(CONFIG_IPSEC_ENC_DES) += libdes/libdes.a
 obj-$(CONFIG_IPSEC_AUTH_HMAC_MD5) += ipsec_md5c.o
 obj-$(CONFIG_IPSEC_AUTH_HMAC_SHA1) += ipsec_sha1.o
 obj-$(CONFIG_IPSEC_IPCOMP) += ipcomp.o zlib/zlib.a
diff -bruN freeswan-1.9.orig/klips/net/ipsec/ipcomp.c freeswan-1.9/klips/net/ipsec/ipcomp.c
--- freeswan-1.9.orig/klips/net/ipsec/ipcomp.c	Mon Jan 29 17:19:22 2001
+++ freeswan-1.9/klips/net/ipsec/ipcomp.c	Mon Jun  4 11:34:31 2001
@@ -14,7 +14,7 @@
  * for more details.
  */
 
-char ipcomp_c_version[] = "RCSID $Id: ipcomp.c,v 1.20 2001/01/29 22:19:22 rgb Exp $";
+char ipcomp_c_version[] = "RCSID $Id: ipcomp.c,v 1.22 2001/05/05 03:31:41 rgb Exp $";
 
 /* SSS */
 
@@ -136,7 +136,7 @@
 	}
 	
 	/* Don't compress packets already fragmented */
-	if (ntohs(iph->frag_off) & ~0x4000) {
+	if (iph->frag_off & __constant_htons(IP_MF | IP_OFFSET)) {
 		KLIPS_PRINT(sysctl_ipsec_debug_ipcomp,
 			    "klips_debug:skb_compress: "
 			    "skipping compression of fragmented packet.\n");
@@ -707,7 +707,9 @@
 		n->mac.raw=skb->mac.raw+offset;
 	else
 		n->mac.raw=NULL;
+#ifndef NETDEV_23
         n->used=skb->used;
+#endif /* !NETDEV_23 */
         n->pkt_type=skb->pkt_type;
 #ifndef NETDEV_23
 	n->pkt_bridged=skb->pkt_bridged;
diff -bruN freeswan-1.9.orig/klips/net/ipsec/ipsec_encap.h freeswan-1.9/klips/net/ipsec/ipsec_encap.h
--- freeswan-1.9.orig/klips/net/ipsec/ipsec_encap.h	Fri Sep  8 15:12:56 2000
+++ freeswan-1.9/klips/net/ipsec/ipsec_encap.h	Mon Jun  4 12:54:13 2001
@@ -13,18 +13,27 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: ipsec_encap.h,v 1.11 2000/09/08 19:12:56 rgb Exp $
+ * RCSID $Id: ipsec_encap.h,v 1.12 2001/05/27 06:12:10 rgb Exp $
  */
 
 #define SENT_IP4	0x0008		/* data is two struct in_addr */
+			/* (2 * sizeof(struct in_addr)) */
+			/* sizeof(struct sockaddr_encap)
+			   - offsetof(struct sockaddr_encap, Sen.Sip4.Src) */
 
 #define SEN_HDRLEN	(2*sizeof(__u8)+sizeof(__u16))
+			/* offsetof(struct sockaddr_encap, Sen.Sip4.Src) */
 
 #define SEN_IP4_SRCOFF	(0)
 #define SEN_IP4_DSTOFF (sizeof (struct in_addr))
+			/* offsetof(struct sockaddr_encap, Sen.Sip4.Dst)
+			   - offsetof(struct sockaddr_encap, Sen.Sip4.Src) */
 #define SEN_IP4_OPTOFF	(2 * sizeof (struct in_addr))
+			/* sizeof(struct sockaddr_encap)
+			   - offsetof(struct sockaddr_encap, Sen.Sip4.Src) */
 
 #define SEN_IP4_LEN	(SENT_HDRLEN + SENT_IP4_OPTOFF)
+			/* sizeof(struct sockaddr_encap) */
 
 #ifdef CONFIG_IPSEC_DEBUG
 #define DB_ER_PROCFS	0x0001
@@ -79,11 +88,13 @@
  * radix tree entry and a SAID (a destination_address/SPI/protocol triple).
  */
 
-struct
-eroute
+struct eroute
 {
 	struct rjtentry er_rjt;
 	struct sa_id er_said;
+	uint32_t er_pid;
+	uint32_t er_count;
+	uint64_t er_lasttime;
 	struct sockaddr_encap er_eaddr;
 	struct sockaddr_encap er_emask;
 };
@@ -106,6 +117,10 @@
 
 /*
  * $Log: ipsec_encap.h,v $
+ * Revision 1.12  2001/05/27 06:12:10  rgb
+ * Added structures for pid, packet count and last access time to eroute.
+ * Added packet count to beginning of /proc/net/ipsec_eroute.
+ *
  * Revision 1.11  2000/09/08 19:12:56  rgb
  * Change references from DEBUG_IPSEC to CONFIG_IPSEC_DEBUG.
  *
diff -bruN freeswan-1.9.orig/klips/net/ipsec/ipsec_esp.h freeswan-1.9/klips/net/ipsec/ipsec_esp.h
--- freeswan-1.9.orig/klips/net/ipsec/ipsec_esp.h	Fri Sep  8 15:12:56 2000
+++ freeswan-1.9/klips/net/ipsec/ipsec_esp.h	Tue Jun 12 15:21:15 2001
@@ -40,6 +40,27 @@
 #define DB_ES_OH	0x0400
 #define DB_ES_REPLAY	0x0800
 
+struct espdesold_xdata
+{
+       int     edx_ivlen;              /* 4 or 8 */
+       union
+       {
+               __u8    Iv[8];          /* that's enough space */
+               __u32   Ivl[2];
+               __u64   Ivq;
+       }Iu;
+#define edx_iv Iu.Iv
+#define edx_ivl Iu.Ivl
+#define edx_ivq Iu.Ivq
+       union
+       {
+               __u8 Rk[8];
+               __u32 Eks[16][2];
+       }Xu;
+#define edx_rk Xu.Rk
+#define edx_eks        Xu.Eks
+};
+
 struct espblkrply_edata
 {
 	__u16	eme_klen;		/* encryption key length */
@@ -64,6 +85,19 @@
 };
 
 #ifdef __KERNEL__
+struct espdesmd5_xdata
+{
+       __u8    edmx_flags;             /* same as before */
+       __u8    edmx_ooowin;            /* out-of-order window size */
+       __u16   edmx_ivlen;             /* IV length */
+       __u32   edmx_bitmap;            /* this&next should be 4 bytes each */
+       __u32   edmx_lastseq;           /* in host order */
+       __u32   edmx_eks[16][2];        /* the key schedule */
+       __u32   edmx_iv[2];             /* constant IV */
+       MD5_CTX edmx_ictx;              /* derived from HMAC_key */
+       MD5_CTX edmx_octx;              /* ditto */
+};
+
 struct esp3desmd5_xdata
 {
 	__u8	edmx_flags;		/* same as before */
@@ -89,6 +123,19 @@
 	MD5_CTX edmx_octx;		/* ditto */
 };
 
+struct espdessha1_xdata
+{
+       __u8    edmx_flags;             /* same as before */
+       __u8    edmx_ooowin;            /* out-of-order window size */
+       __u16   edmx_ivlen;             /* IV length */
+       __u32   edmx_bitmap;            /* this&next should be 4 bytes each */
+       __u32   edmx_lastseq;           /* in host order */
+       __u32   edmx_eks[16][2];        /* the key schedule */
+       __u32   edmx_iv[2];             /* constant IV */
+       SHA1_CTX edmx_ictx;             /* derived from HMAC_key */
+       SHA1_CTX edmx_octx;             /* ditto */
+};
+
 struct esp3dessha1_xdata
 {
 	__u8	edmx_flags;		/* same as before */
@@ -114,6 +161,17 @@
 	SHA1_CTX edmx_octx;		/* ditto */
 };
 
+struct espdes_xdata
+{
+       __u8    edmx_flags;             /* same as before */
+       __u8    edmx_ooowin;            /* out-of-order window size */
+       __u16   edmx_ivlen;             /* IV length */
+       __u32   edmx_bitmap;            /* this&next should be 4 bytes each */
+       __u32   edmx_lastseq;           /* in host order */
+       __u32   edmx_eks[16][2];        /* the key schedule */
+       __u32   edmx_iv[2];             /* constant IV */
+};
+
 struct esp3des_xdata
 {
 	__u8	edmx_flags;		/* same as before */
@@ -165,9 +223,6 @@
  * $Log: ipsec_esp.h,v $
  * Revision 1.13  2000/09/08 19:12:56  rgb
  * Change references from DEBUG_IPSEC to CONFIG_IPSEC_DEBUG.
- *
- * Revision 1.12  2000/08/01 14:51:50  rgb
- * Removed _all_ remaining traces of DES.
  *
  * Revision 1.11  2000/01/10 16:36:20  rgb
  * Ditch last of EME option flags, including initiator.
